/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Le=require("react"),e=require("prop-types"),O=require("@progress/kendo-date-math"),Q=require("@progress/kendo-react-buttons"),ee=require("@progress/kendo-svg-icons"),te=require("@progress/kendo-react-intl"),l=require("@progress/kendo-react-common"),pe=require("@progress/kendo-react-labels"),Ne=require("@progress/kendo-dateinputs-common"),N=require("./utils.js"),Ae=require("../package-metadata.js"),c=require("../utils.js"),s=require("../messages/index.js"),_e=require("../timepicker/utils.js"),Be=require("../common/ClearButton.js"),je=require("./dateInputIntl.js");function Fe(t){const b=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(t){for(const m in t)if(m!=="default"){const E=Object.getOwnPropertyDescriptor(t,m);Object.defineProperty(b,m,E.get?E:{enumerable:!0,get:()=>t[m]})}}return b.default=t,Object.freeze(b)}const r=Fe(Le),He="Please enter a valid value!",_=r.forwardRef((t,b)=>{var Z;l.validatePackage(Ae.packageMetadata);const m=l.useId(t.id),E=te.useInternationalization(),C=te.useLocalization(),ne=l.useUnstyled(),B=l.usePropsContext(A,t).unstyled||ne,{format:k=i.format,size:ae=i.size,rounded:re=i.rounded,fillMode:ie=i.fillMode,formatPlaceholder:le=i.formatPlaceholder,spinners:ue=i.spinners,disabled:R=i.disabled,min:oe=i.min,max:se=i.max,minTime:ce=i.minTime,maxTime:de=i.maxTime,validityStyles:fe=i.validityStyles,validationMessage:j=i.validationMessage,placeholder:y=i.placeholder,enableMouseWheel:me=i.enableMouseWheel,autoCorrectParts:ge=i.autoCorrectParts,autoSwitchParts:ve=i.autoSwitchParts,allowCaretMode:be=i.allowCaretMode,twoDigitYearMax:ye=i.twoDigitYearMax,ariaHasPopup:he=i.ariaHasPopup,autoFocus:De=i.autoFocus}=l.usePropsContext(A,t),g=()=>P.current!==void 0?P.current:u.current&&u.current.value,Ie=()=>{const{year:n,month:a,day:I,hours:T,minutes:S,seconds:q}=w.current;return(!n||!a||!I||!T||!S||!q)&&(n||a||I||T||S||q)},F=()=>{const n=u.current&&u.current.currentText||"",a=g();return y!=null&&!qe.focused&&!a?y:n},H=()=>t.required!==void 0?t.required:!1,V=()=>{const n=g()||t.value,a=oe,I=se,T=N.isInRange(n,a,I)&&_e.isInTimeRange(n,ce,de),S=j!==void 0,q=(!H()||n!=null)&&T,Ve=t.valid!==void 0?t.valid:q;return{customError:S,rangeOverflow:n&&I.getTime()<n.getTime()||!1,rangeUnderflow:n&&n.getTime()<a.getTime()||!1,valid:Ve,valueMissing:n===null}},Oe=()=>{o.current&&o.current.focus()},z=()=>new je.DateInputIntl(E),x=()=>{const n=g();return{format:k,steps:t.steps,formatPlaceholder:le,placeholder:y,selectPreviousSegmentOnBackspace:!0,value:t.value||n,intlService:z(),autoFill:t.autoFill!==void 0?t.autoFill:!1,enableMouseWheel:me,autoCorrectParts:ge,autoSwitchParts:ve,autoSwitchKeys:t.autoSwitchKeys||[],twoDigitYearMax:ye,allowCaretMode:be}},Ee=n=>{d.current&&d.current.classList.add("k-focus"),J({focused:!0})},Ce=n=>{d.current&&d.current.classList.remove("k-focus"),J({focused:!1})},Re=(n,a)=>typeof n!=typeof a?!0:typeof n=="string"&&typeof a=="string"?n!==a:typeof n=="object"&&typeof a=="object"?JSON.stringify(n)!==JSON.stringify(a):!1,xe=n=>typeof n=="string"?n:{inputFormat:n,displayFormat:n},U=n=>{P.current=g(),ke(),v.current=n,P.current=void 0},W=n=>{t.onChange&&t.onChange(n)},K=n=>{l.getActiveElement(document)===o.current&&n.preventDefault()},Me=()=>new Ne.DateInput(o.current,{...x(),format:xe(x().format),events:{focus:Ee,blur:Ce,valueChange:U,click:W}}),Y=()=>{o.current&&o.current.setCustomValidity&&o.current.setCustomValidity(V().valid?"":j||i.validationMessage)},we=n=>{!o.current||!u.current||U(n)},Pe=n=>{n.preventDefault();const a=l.getActiveElement(document);o.current&&a!==o.current&&o.current.focus({preventScroll:!0})},f=n=>{const a=g();v.current&&t.onChange&&!O.isEqual(v.current.oldValue,a)&&t.onChange.call(void 0,{syntheticEvent:n,nativeEvent:v.current.event,value:v.current.value,target:M.current}),v.current=null},Te=n=>{var a;(a=u.current)==null||a.modifyDateSegmentValue(1),f(n)},Se=n=>{var a;(a=u.current)==null||a.modifyDateSegmentValue(-1),f(n)},M=r.useRef(null),o=r.useRef(null),d=r.useRef(null);r.useImperativeHandle(M,()=>({props:t,get options(){return x()},get text(){return F()},get element(){return o.current},get name(){return t.name},get value(){return g()},get validity(){return V()},focus:Oe,updateOnPaste:we})),r.useImperativeHandle(b,()=>M.current);const u=r.useRef(null),w=r.useRef(null),L=r.useRef(!1),P=r.useRef(null),v=r.useRef(null),h=r.useRef(t),[qe,J]=r.useState({focused:!1}),[,ke]=r.useReducer(n=>n+1,0);r.useLayoutEffect(()=>{L.current||(u.current=Me(),w.current=u.current.dateObject,L.current=!0)},[]),r.useEffect(()=>(Y(),L.current||d.current&&d.current.addEventListener("wheel",K,{passive:!1}),()=>{d.current&&d.current.removeEventListener("wheel",K)}),[]),r.useEffect(()=>{Y(),u.current&&((Re(h.current.format,k)||h.current.readonly!==t.readonly||h.current.steps!==t.steps||z().locale!==u.current.options.intlService.locale)&&u.current.setOptions(x(),!0),h.current.value!==t.value&&(w.current.getValue()!==null||Ie()&&t.value!==null)&&w.current.setValue(t.value),t.ariaExpanded!==void 0&&t.ariaExpanded&&(u.current.options.placeholder=null),t.ariaExpanded!==void 0&&!t.ariaExpanded&&(u.current.options.placeholder=y),u.current.refreshElementValue(),h.current={format:k,readonly:t.readonly,ariaExpanded:t.ariaExpanded,steps:t.steps,value:t.value})});const X=t.id||m+"-accessibility-id",D=B&&B.uDateInput,$=F(),p=!fe||V().valid;t._ref&&(t._ref.current=M.current);const G=r.createElement("span",{ref:n=>d.current=n,style:t.label?void 0:{width:t.width},dir:t.dir,className:l.classNames(l.uDateInput.wrapper({c:D,size:ae,fillMode:ie,rounded:re,disabled:R,required:H(),invalid:!p}),t.className)},r.createElement("input",{ref:n=>o.current=n,role:t.ariaRole||"textbox",readOnly:t.readonly,tabIndex:t.tabIndex||0,disabled:R,title:t.title!==void 0?t.title:$,type:"text",spellCheck:!1,autoComplete:"off",autoCorrect:"off",autoFocus:De,className:l.classNames(l.uDateInput.inputInner({c:D})),id:X,value:$,"aria-label":t.ariaLabel,"aria-labelledby":t.ariaLabelledBy,"aria-describedby":t.ariaDescribedBy,"aria-haspopup":he,"aria-disabled":R,"aria-expanded":t.ariaExpanded,"aria-controls":t.ariaControls,"aria-required":t.required,"aria-invalid":!p,onKeyDown:f,onChange:f,onWheel:f,onInput:f,onClick:f,name:t.name,...t.inputAttributes}),t.children,t.clearButton&&t.value&&r.createElement(Be,{onClick:W,key:"clearbutton"}),ue&&r.createElement("span",{className:l.classNames(l.uDateInput.inputSpinner({c:D})),onMouseDown:Pe},r.createElement(Q.Button,{tabIndex:-1,type:"button",rounded:null,className:l.classNames(l.uDateInput.spinnerIncrease({c:D})),icon:"caret-alt-up",svgIcon:ee.caretAltUpIcon,"aria-label":C.toLanguageString(s.increaseValue,s.messages[s.increaseValue]),title:C.toLanguageString(s.increaseValue,s.messages[s.increaseValue]),onClick:Te}),r.createElement(Q.Button,{tabIndex:-1,type:"button",rounded:null,className:l.classNames(l.uDateInput.spinnerDecrease({c:D})),icon:"caret-alt-down",svgIcon:ee.caretAltDownIcon,"aria-label":C.toLanguageString(s.decreaseValue,s.messages[s.decreaseValue]),title:C.toLanguageString(s.decreaseValue,s.messages[s.decreaseValue]),onClick:Se})));return t.label?r.createElement(pe.FloatingLabel,{label:t.label,editorId:X,editorValue:(Z=o.current)==null?void 0:Z.value,editorValid:p,editorDisabled:R,children:G,style:{width:t.width}}):G});_.propTypes={value:e.instanceOf(Date),format:e.oneOfType([c.nullable(e.string),e.shape({skeleton:e.string,pattern:e.string,date:e.oneOf(["short","medium","long","full"]),time:e.oneOf(["short","medium","long","full"]),datetime:e.oneOf(["short","medium","long","full"]),era:e.oneOf(["narrow","short","long"]),year:e.oneOf(["numeric","2-digit"]),month:e.oneOf(["numeric","2-digit","narrow","short","long"]),day:e.oneOf(["numeric","2-digit"]),weekday:e.oneOf(["narrow","short","long"]),hour:e.oneOf(["numeric","2-digit"]),hour12:e.bool,minute:e.oneOf(["numeric","2-digit"]),second:e.oneOf(["numeric","2-digit"]),timeZoneName:e.oneOf(["short","long"])})]),formatPlaceholder:e.oneOfType([e.oneOf(["wide","narrow","short","formatPattern"]).isRequired,e.shape({year:e.string.isRequired,month:e.string.isRequired,day:e.string.isRequired,hour:e.string.isRequired,minute:e.string.isRequired,second:e.string.isRequired})]),width:e.oneOfType([e.string,e.number]),tabIndex:e.number,title:e.string,steps:e.shape({year:c.nullable(e.number),month:c.nullable(e.number),day:c.nullable(e.number),hour:c.nullable(e.number),minute:c.nullable(e.number),second:c.nullable(e.number)}),min:e.instanceOf(Date),max:e.instanceOf(Date),disabled:e.bool,spinners:e.bool,name:e.string,dir:e.string,label:e.string,id:e.string,ariaLabelledBy:e.string,ariaDescribedBy:e.string,ariaLabel:e.string,ariaRole:e.string,ariaHasPopup:e.oneOfType([e.bool,e.oneOf(["grid","dialog"])]),ariaExpanded:e.oneOfType([e.bool]),onChange:e.func,validationMessage:e.string,required:e.bool,valid:e.bool,size:e.oneOf([null,"small","medium","large"]),rounded:e.oneOf([null,"small","medium","large","full"]),fillMode:e.oneOf([null,"solid","flat","outline"]),autoFocus:e.bool,inputAttributes:e.object};const i={format:N.DEFAULT_FORMAT,size:"medium",rounded:"medium",fillMode:"solid",formatPlaceholder:N.DEFAULT_FORMAT_PLACEHOLDER,spinners:!1,disabled:!1,max:O.cloneDate(c.MAX_DATE),min:O.cloneDate(c.MIN_DATE),minTime:O.cloneDate(c.MIN_TIME),maxTime:O.cloneDate(c.MAX_TIME),validityStyles:!0,validationMessage:He,placeholder:null,enableMouseWheel:!0,autoCorrectParts:!0,autoSwitchParts:!0,allowCaretMode:!1,twoDigitYearMax:68,ariaHasPopup:"grid",autoFocus:!1},A=l.createPropsContext();_.displayName="KendoReactDateInput";exports.DateInput=_;exports.DateInputPropsContext=A;exports.dateInputDefaultProps=i;
